module Ubc.Parse.Syntax.ParserState
( ParserState(..)
, initialState
, pushScope
, popScope
, modifyScope
)
where

import Ubc.Parse.Syntax.Scope (Scope)
import Ubc.Parse.Syntax.Config (Config)

data ParserState = ParserState
        { scopes :: [Scope]
        , config :: Config
        }

initialState :: Config -> ParserState
initialState = ParserState []

pushScope :: Scope -> ParserState -> ParserState
pushScope scope oldState@ParserState{scopes = oldScopes} = oldState{scopes = scope : oldScopes}

popScope :: ParserState -> (ParserState, Scope)
popScope oldState@ParserState{scopes = (topScope:restScopes)} = (oldState{scopes = restScopes}, topScope)

modifyScope :: (Scope -> Scope) -> ParserState -> ParserState
modifyScope f oldState@ParserState{scopes = (topScope:restScopes)} = oldState{scopes = f topScope : restScopes}
