module Ubc.Parse.Syntax.Types
( checkTypeValidity
, getTypeNames
)
where

import qualified Data.Set as Set

import Text.Parsec ( ParsecT )

import Ubc.Parse.Syntax.ParserState (ParserState)
import Control.Monad ((<$!>))

checkTypeValidity :: Monad m => String -> ParsecT String ParserState m Bool
checkTypeValidity typeName = do
        typeNames <- Set.union (Set.fromList ["i32", "u32", "f32"]) . Set.fromList <$!> getTypeNames
        return $ typeName `Set.member` typeNames

getTypeNames :: Monad m => ParsecT String ParserState m [String]
getTypeNames = do
        return []
